addHook("ThinkFrame", do
    for player in players.iterate
		if (player.spectator) return end
        if (player.cmd.buttons & BT_USE)
        and player.mo.skin == "why"
        and not (player.weapondelay) 
        and not (player.powers[pw_carry] == CR_NIGHTSMODE) 
        and not P_IsObjectOnGround(player.mo)
        and not (player.powers[pw_carry] == CR_ROPEHANG) 
        and not (player.pflags & PF_SPINNING)
		and (gametype ~= GT_EXEAMONGUS)
		and (gametype ~= GT_EXESURVIVAL)

            player.pflags = $1|PF_JUMPED
            player.pflags = $1|PF_THOKKED

            if player.mo.momz > -2*FRACUNIT
            and player.mo.momz < 1*FRACUNIT
                player.mo.momz = 1
            else
                if player.mo.momz > 1*FRACUNIT
                    player.mo.momz = player.mo.momz/76
                end
                if player.mo.momz < -1*FRACUNIT
                   player.mo.momz = player.mo.momz/1
                end
            end
        end
    end
end)
	
addHook("ThinkFrame", do
    for player in players.iterate
		if (player.spectator) return end
        if player.mo and player.mo.skin == "why"
        player.powers[pw_underwater] = 0
        end
    end
end)

addHook("ThinkFrame", do
	for player in players.iterate
		if (player.spectator) return end
            if player.mo and player.mo.skin == "why"
			if (player.cmd.buttons & BT_CUSTOM1)
            and not (player.mo.eflags & MFE_UNDERWATER)
			and not (player.powers[pw_carry] == CR_NIGHTSMODE) //no shooting when NiGHTS Super Sonic!
			and not (player.powers[pw_carry] == CR_ROPEHANG) //rope hangs use spin for letting go
			and not (player.powers[pw_carry] == CR_MACESPIN) //control chains use spin for shifting angle I think?	
			and not (player.mo.tracer and player.mo.tracer.type == MT_TUBEWAYPOINT) //no shooting when following a zoomtube
			and P_IsObjectOnGround(player.mo)
			and not G_RingSlingerGametype()
			and not (CBW_Battle)
			and (gametype ~= GT_EXEAMONGUS)
			and (gametype ~= GT_EXESURVIVAL)
			P_ElementalFire(player, false)
	end
  end
end
end)

freeslot("sfx_shot")
sfxinfo[sfx_shot].caption = "Whoosh"

addHook("ThinkFrame", do
	for player in players.iterate
		if (player.spectator) return end
		if player.mo and player.mo.skin == "why"
			if not (player.mo.custom2down)
				player.mo.custom2down = 0
			end
			if (player.cmd.buttons & BT_CUSTOM2)
			and not (player.powers[pw_carry] == CR_NIGHTSMODE) //no shooting when NiGHTS Super Sonic!
			and not (player.powers[pw_carry] == CR_ROPEHANG) //rope hangs use spin for letting go
			and not (player.powers[pw_carry] == CR_MACESPIN) //control chains use spin for shifting angle I think?
			and not (player.pflags & PF_GAMETYPEOVER) //no shooting when tagged
			and not (player.pflags & PF_STASIS) //no shooting when in stasis in tag mode either
			and not (player.mo.tracer and player.mo.tracer.type == MT_TUBEWAYPOINT) //no shooting when following a zoomtube
			and not (player.pflags & PF_SPINNING) //no shooting when ...spinning?
			and player.mo.custom2down == 0
			and not G_RingSlingerGametype()
			and not (CBW_Battle)
			and (gametype ~= GT_EXEAMONGUS)
			and (gametype ~= GT_EXESURVIVAL)
				player.mo.custom2down = 1
				local an = player.mo.angle
				local slope = player.aiming
				S_StartSound(player.mo, sfx_shot)
				local th = P_SpawnMobj(player.mo.x + (1*cos(an)), player.mo.y + (1*sin(an)), player.mo.z+6*FRACUNIT, MT_SHOOTSPIKE)
				//Missile copies player's scale
				th.scale = player.mo.scale
				// missiles can't hurt their targets, note
				th.target = player.mo
				//Determine speed
				local speed = 70*FRACUNIT
				if player.mo.eflags & MFE_VERTICALFLIP then
					th.flags2 = $1|MF2_OBJECTFLIP // flip gravity!
					th.z = $1 - th.height - player.mo.height/3
				end
				th.angle = an
				th.momx = FixedMul(speed, cos(an))
				th.momy = FixedMul(speed, sin(an))
				th.momx = FixedMul(th.momx, cos(slope))
				th.momy = FixedMul(th.momy, cos(slope))
				th.momz = FixedMul(speed, sin(slope))	
			end
			if not (player.cmd.buttons & BT_CUSTOM2)
				player.mo.custom2down = 0
			end
		end
	end
end)